
/*********************************************************************
 * (C) Copyright 1999 Albert Ludwigs University Freiburg
 *     Institute of Computer Science
 *
 * All rights reserved. Use of this software is permitted for 
 * non-commercial research purposes, and it may be copied only 
 * for that use.  All copies must include this copyright message.
 * This software is made available AS IS, and neither the authors
 * nor the  Albert Ludwigs University Freiburg make any warranty
 * about the software or its performance. 
 *********************************************************************/

/*********************************************************************
 * File: cnfout.h
 * Description: headers for cnf output
 *
 * Author: Joerg Hoffmann 2003
 *
 *********************************************************************/ 

//Modified by Nathan Robinson, May 2008, Griffith University
// Copyright of the modifications (c) 2008 National ICT Australia Limited (NICTA)
//
// Author: Nathan Robinson (nathan.robinson@nicta.com.au)
//
// Redistribution and use in source and binary forms, with or without
// modification and only for non-commercial research and educational
// purposes are permitted provided that the conditions in the
// accompanying file "licence.txt" are met.

#ifndef _CNFOUT_H
#define _CNFOUT_H

#include "bb.hh"
#include "output.hh"
#include "memory.hh"
#include "instantiateI.hh"
#include "instantiateII.hh"
#include "graph.hh"

//NATHAN
#include <assert.h>
#include "cppheader.hh"
#define MAX_CLAUSES 20000000
#define MAX_CNF_VARS 1000000

//NATHAN
template <typename T> string toString(const T &thing) {
    stringstream os; os << thing; return os.str();
}

//Modified by NATHAN
void do_cnf_output( int prevBestScore );
//Modified by NATHAN
void print_gp_based_encoding(int layer, int prevBestScore);

#endif /* _CNFOUT_H */
