// Copyright (c) 2008 National ICT Australia Limited (NICTA)
//
// Author: Charles Gretton (charles.gretton@nicta.com.au)
//
// Redistribution and use in source and binary forms, with or without
// modification and only for non-commercial research and educational
// purposes are permitted provided that the conditions in the
// accompanying file "licence.txt" are met.

#include "global.hh"

namespace MemoryManagement{
    vector<void*> toDelete;
}

IntAndDouble::IntAndDouble(int i):i(i),
				  d(static_cast<double>(i)),
				  wasInt(true),
				  wasDouble(false)
{}

IntAndDouble::IntAndDouble(double d):i(static_cast<int>(d)),
				     d(d),
				     wasInt(false),
				     wasDouble(true)
{}

int IntAndDouble::getVal(int) const{return i;}
double IntAndDouble::getVal(double) const{return d;}

bool IntAndDouble::isInt() const {return wasInt;}
bool IntAndDouble::isDouble() const {return wasDouble;}


bool HasStringRepresentation::operator<(const HasStringRepresentation& hsr) const
{
    VERBOSER(5, "Calling LEQ test for HasStringRepresentation.\n");
    
    ostringstream oss;
    oss<<*this;
    ostringstream oss1;
    oss1<<hsr;

    VERBOSER(5, "EQ test between "
	     <<*this<<" and "<<hsr<<" yields :: "<<(oss.str() < oss1.str())<<endl);
    
    return oss.str() < oss1.str();
}

bool HasStringRepresentation::operator==(const HasStringRepresentation& hsr) const
{
    VERBOSER(5, "Calling EQ test for HasStringRepresentation.\n");
    ostringstream oss;
    oss<<*this;
    ostringstream oss1;
    oss1<<hsr;

    VERBOSER(5, "EQ test between "
	     <<*this<<" and "<<hsr<<" yields :: "<<(oss.str() == oss1.str())<<endl);
    
    return oss.str() == oss1.str();
}

ostream& operator<<(ostream& o,
		    const HasStringRepresentation& hasStringRepresentation)
{
    if(!hasStringRepresentation.computedAsString){
	hasStringRepresentation.computeAsString("");
    }
    
    return o<<hasStringRepresentation.asString;
}
