

/*********************************************************************
 * (C) Copyright 1999 Albert Ludwigs University Freiburg
 *     Institute of Computer Science
 *
 * All rights reserved. Use of this software is permitted for 
 * non-commercial research purposes, and it may be copied only 
 * for that use.  All copies must include this copyright message.
 * This software is made available AS IS, and neither the authors
 * nor the  Albert Ludwigs University Freiburg make any warranty
 * about the software or its performance. 
 *********************************************************************/


/*********************************************************************
 * File: instantiateII.h
 * Description: headers for instantiating operators, second part.
 *
 *              - unify inertia in preconds with initial state
 *              - multiply remaining uninstantiated parameters
 *              - perform reachability analysis
 *              - collect relevant facts and perform final action cleanup
 *
 *
 * Author: Joerg Hoffmann 1999
 *
 *********************************************************************/ 

//Modified by Nathan Robinson, May 2008, Griffith University
// Copyright of the modifications (c) 2008 National ICT Australia Limited (NICTA)
//
// Author: Nathan Robinson (nathan.robinson@nicta.com.au)
//
// Redistribution and use in source and binary forms, with or without
// modification and only for non-commercial research and educational
// purposes are permitted provided that the conditions in the
// accompanying file "licence.txt" are met.

#ifndef _INSTANTIATEII_H
#define _INSTANTIATEII_H

//NATHAN
void copy_action_templates_from_parser(const Planning::CostPlanner &planner);

void build_action_templates( void );
void unify_inertia_preconds( int curr_inertia );
void multiply_parameters( int curr_parameter );

void perform_reachability_analysis( void );
int fact_adress( void );

void collect_relevant_facts( void );

void build_connectivity_graph( void );

void insert_bit_vectors( void );



#endif /* _INSTANTIATEII_H */

